create or replace procedure pr_ndv_inv3(ncompany  in number,
                                        sjur_pers in varchar2,
                                        sstore    in varchar2,
                                        sacc      in varchar2,
                                        ddate     in varchar2,
                                        test      in out sys_refcursor) is
dddate date;
ddateost date;                                        
begin
dddate:=to_date(ddate,'dd.mm.yyyy');
ddateost:=to_date('01.'||to_char(dddate,'mm.yyyy'),'dd.mm.yyyy');
  open test for
      select ost.*,
           st.azs_number,
           agn2.agnname jpname,
           agn.agnabbr smol,
                   nvl((select val.acnt_remn_sum
                 from valremns val
                where val.nomenclature = ost.nomrn
                  and val.jur_pers = ost.jur_pers
                  and val.remn_date = ddateost
                  and val.agent = agn.rn),
               0) + nvl((select sum(opr.acnt_base_sum)
                          from oprspecs opr, dicaccs acc, econoprs ec
                         where opr.account_debit = acc.rn
                           and acc.acc_number = sacc 
                           and opr.prn = ec.rn
                           and ec.agent_to = agn.rn
                           and opr.nomenclature = ost.nomrn
                           and opr.jur_pers = ost.jur_pers
                           and opr.operation_date between
                               ddateost and
                               dddate),
                        0) -
           nvl((select sum(opr.acnt_base_sum)
                 from oprspecs opr, dicaccs acc, econoprs ec
                where opr.account_credit = acc.rn
                  and acc.acc_number = sacc 
                  and opr.prn = ec.rn
                  and ec.agent_from = agn.rn
                  and opr.nomenclature = ost.nomrn
                  and opr.jur_pers = ost.jur_pers
                  and opr.operation_date between
                      ddateost and
                      dddate),
               0) summ,
               
           nvl((select val.acnt_remn_quant
                 from valremns val
                where val.nomenclature = ost.nomrn
                  and val.jur_pers = ost.jur_pers
                  and val.remn_date = ddateost
                  and val.agent = agn.rn),
               0) + nvl((select sum(opr.acnt_quant)
                          from oprspecs opr, dicaccs acc, econoprs ec
                         where opr.account_debit = acc.rn
                           and acc.acc_number = sacc 
                           and opr.prn = ec.rn
                           and ec.agent_to = agn.rn
                           and opr.nomenclature = ost.nomrn
                           and opr.jur_pers = ost.jur_pers
                           and opr.operation_date between
                               ddateost and
                               dddate),
                        0) -
           nvl((select sum(opr.acnt_quant)
                 from oprspecs opr, dicaccs acc, econoprs ec
                where opr.account_credit = acc.rn
                  and acc.acc_number = sacc 
                  and opr.prn = ec.rn
                  and ec.agent_from = agn.rn
                  and opr.nomenclature = ost.nomrn
                  and opr.jur_pers = ost.jur_pers
                  and opr.operation_date between
                      ddateost and
                      dddate),
               0) ost
      from (select strop.company,
                   ind.jur_pers,
                   gds.store,
                   dicn.rn nomrn,
                   dicn.nomen_code,
                   dicn.nomen_name,
                   dicm.meas_mnemo,
                   dicm.meas_name,
                   sum(decode(strop.oper_type, 1, strop.quant, -strop.quant)) quant
              from storeoperjourn strop,
                   goodssupply    gds,
                   goodsparties   gdp,
                   nommodif       nom,
                   dicnomns       dicn,
                   incomdoc       ind,
                   dicmunts       dicm
             where strop.goodssupply = gds.rn
               and gds.prn = gdp.rn
               and gdp.nommodif = nom.rn
               and nom.prn = dicn.rn
               and gdp.indoc = ind.rn
               and ind.company=ncompany
               and dicn.umeas_main=dicm.rn
               and strop.operdate <= dddate
               group by strop.company,
                      ind.jur_pers,
                      gds.store,
                      dicn.rn,
                      dicn.nomen_code,
                      dicn.nomen_name,
                      dicm.meas_mnemo,
                      dicm.meas_name
            having sum(decode(strop.oper_type, 1, strop.quant, -strop.quant)) != 0) ost,
           azsazslistmt st,
           agnlist agn,
           jurpersons jp,
           agnlist agn2
     where st.rn = ost.store
       and st.azs_number = sstore
       and st.azs_agent = agn.rn
       and ost.jur_pers= jp.rn
       and jp.code=sjur_pers
       and jp.company=ncompany
       and jp.agent=agn2.rn   
     order by ost.nomen_name; 
end pr_ndv_inv3;
/
